<template>
  <div class="got-gallery">
		<div class="gallery-options">
			<input type="text" v-model="search" placeholder="Chercher un personnage">
		</div>
		<div class="gallery">
			<!-- choisir une case unique (name quand j'aurai enlevé les doubles) -->
			<GotCard
				v-for="got in sortGotData"
				:key="got.id" 
				:name="got.name"
				:culture="got.gender"
			/>
		</div>
		<button v-show="NumPage != 1" v-on:click="first()">First</button>
		<button v-show="NumPage > 1" v-on:click="searchByPage(-1)">Previous</button>
		<button v-show="NumPage < 43" v-on:click="searchByPage(1)">Next</button>
		<button v-show="NumPage != 43" v-on:click="last()">Last</button>
  </div>
</template>

<script>
import GotCard from './GotCard.vue'
import getGotData from '@/services/api/gotRepository.js'

export default {
  name: 'GotGallery',
	data() {
		return {
			GotData: [],
			NumPage: 1,
			search: ""
		}
	},
	computed: {
		sortGotData: function() {
			return this.GotData
				.filter(searching => {
					return searching.name.toLowerCase().includes(this.search.toLowerCase())
				})
		}
	},
	created: function() {
		this.retrieveGotData()
	},
	methods: {
		async retrieveGotData(NumPage) {
			this.GotData = await getGotData(NumPage);
		},
		async searchByPage(nbPage) {
			this.NumPage+=nbPage;
			this.GotData = await getGotData(this.NumPage);
		},
		async first(){
			this.NumPage=1;
			this.GotData = await getGotData(this.NumPage);
		},
		async last(){
			this.NumPage=43;
			this.GotData = await getGotData(this.NumPage);
		}
	},
	components: {
		GotCard
	}
}
</script>

<style></style>